unit SmoothLine;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, MathX, SmoothLineBox, SmoothLn, TimerEx;

type
  TForm1 = class(TForm)
    SmoothLn1: TSmoothLn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    TimerEx1: TTimerEx;
    procedure SmoothLn1Paint(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TimerEx1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
var
   {Variables for animation using CopyRect method}
   FrameX : Integer;
   FrameY : Integer;

procedure TForm1.SmoothLn1Paint(Sender: TObject);

begin
     {Display Page1 image on visible canvas when OnPaint event occurs}
     SmoothLn1.Canvas.Draw(0,0,SmoothLn1.Page1);
end;

procedure TForm1.FormActivate(Sender: TObject);
var
   {Variables for creating pinwheel images}
   XFrames : integer;
   YFrames : integer;
   RotationAngle : integer;
begin
     {Initialize pinwheel variables}
     FrameX := 0;
     FrameY := 0;
     {Set Bitmap Page1 Width and Height (size is 0 by 0 until set)}
     SmoothLn1.Page1.Width := 400;
     SmoothLn1.Page1.Height := 400;
     {Set Bitmap Page1 Width and Height}
     SmoothLn1.Page2.Width := 1000;
     SmoothLn1.Page2.Height := 900;
     {Set visible Canvas copymode}
     SmoothLn1.Canvas.CopyMode := cmSrcCopy;
     {Erase Bitmap Page1 to black}
     SmoothLn1.Erase(1,clBlack);
     {Erase Bitmap Page2 to black}
     SmoothLn1.Erase(2,clBlack);
     {Set Canvas Pen mode to merge}
     SmoothLn1.Page1.Canvas.Pen.Mode := pmMerge;
     {Draw overlapping Red, Green, and Blue lines with normal pen, pmMerge}
     SmoothLn1.Page1.Canvas.Pen.Width := 2;
     SmoothLn1.Page1.Canvas.Pen.Color := clRed;
     SmoothLn1.Page1.Canvas.MoveTo(0,10);
     SmoothLn1.Page1.Canvas.LineTo(300,40);
     SmoothLn1.Page1.Canvas.Pen.Color := clLime;
     SmoothLn1.Page1.Canvas.MoveTo(0,25);
     SmoothLn1.Page1.Canvas.LineTo(300,25);
     SmoothLn1.Page1.Canvas.Pen.Color := clBlue;
     SmoothLn1.Page1.Canvas.MoveTo(0,40);
     SmoothLn1.Page1.Canvas.LineTo(300,10);
     {Draw overlapping Red, Green, and Blue lines with SmoothPen,pmMerge}
     SmoothLn1.SmoothPen.Width := 2;
     SmoothLn1.SmoothPen.Mode := pmMerge;
     SmoothLn1.SmoothPen.Color := clRed;
     SmoothLn1.Page1.Canvas.MoveTo(0,60);
     SmoothLn1.SmoothLineTo(300,90,1);
     SmoothLn1.SmoothPen.Color := clLime;
     SmoothLn1.Page1.Canvas.MoveTo(0,75);
     SmoothLn1.SmoothLineTo(300,75,1);
     SmoothLn1.SmoothPen.Color := clBlue;
     SmoothLn1.Page1.Canvas.MoveTo(0,90);
     SmoothLn1.SmoothLineTo(300,60,1);

     {Draw overlapping Red, Green, and Blue spots with SmoothPen, pmMerge}
     SmoothLn1.SmoothPen.Width := 30;
     SmoothLn1.SmoothPen.Mode := pmMerge;
     SmoothLn1.SmoothPen.Color := clRed;
     SmoothLn1.Spot(350,70,1);
     SmoothLn1.SmoothPen.Color := clLime;
     SmoothLn1.Spot(365,70,1);
     SmoothLn1.SmoothPen.Color := clBlue;
     SmoothLn1.Spot(357,82,1);

     {Draw overlapping Red, Green, and Blue lines with normal pen, pmCopy}
     SmoothLn1.Page1.Canvas.Pen.Mode := pmCopy;
     SmoothLn1.Page1.Canvas.Pen.Width := 2;
     SmoothLn1.Page1.Canvas.Pen.Color := clRed;
     SmoothLn1.Page1.Canvas.MoveTo(0,110);
     SmoothLn1.Page1.Canvas.LineTo(300,140);
     SmoothLn1.Page1.Canvas.Pen.Color := clLime;
     SmoothLn1.Page1.Canvas.MoveTo(0,125);
     SmoothLn1.Page1.Canvas.LineTo(300,125);
     SmoothLn1.Page1.Canvas.Pen.Color := clBlue;
     SmoothLn1.Page1.Canvas.MoveTo(0,140);
     SmoothLn1.Page1.Canvas.LineTo(300,110);
     {Draw overlapping Red, Green, and Blue lines with SmoothPen, pmCopy}
     SmoothLn1.SmoothPen.Mode := pmCopy;
     SmoothLn1.SmoothPen.Width := 2;;
     SmoothLn1.SmoothPen.Color := clRed;
     SmoothLn1.Page1.Canvas.MoveTo(0,160);
     SmoothLn1.SmoothLineTo(300,190,1);
     SmoothLn1.SmoothPen.Color := clLime;
     SmoothLn1.Page1.Canvas.MoveTo(0,175);
     SmoothLn1.SmoothLineTo(300,175,1);
     SmoothLn1.SmoothPen.Color := clBlue;
     SmoothLn1.Page1.Canvas.MoveTo(0,190);
     SmoothLn1.SmoothLineTo(300,160,1);

     {Draw overlapping Red, Green, and Blue spots with SmoothPen, pmMerge}
     SmoothLn1.SmoothPen.Width := 30;
     SmoothLn1.SmoothPen.Mode := pmCopy;
     SmoothLn1.SmoothPen.Color := clRed;
     SmoothLn1.Spot(350,170,1);
     SmoothLn1.SmoothPen.Color := clLime;
     SmoothLn1.Spot(365,170,1);
     SmoothLn1.SmoothPen.Color := clBlue;
     SmoothLn1.Spot(357,182,1);

     {Sample of SmoothPolygons}
     SmoothLn1.SmoothPen.Mode := pmCopy;
     SmoothLn1.SmoothPen.Width := 1;
     SmoothLn1.SmoothPen.Color := clWhite;
     SmoothLn1.SmoothPolygon(20,220,15,3,60,1);
     SmoothLn1.SmoothPolygon(50,220,15,3,0,1);
     SmoothLn1.SmoothPolygon(80,220,15,3,30,1);
     SmoothLn1.SmoothPolygon(110,220,15,3,-30,1);
     SmoothLn1.SmoothPolygon(140,220,15,5,0,1);
     SmoothLn1.SmoothPolygon(170,220,15,5,36,1);
     SmoothLn1.SmoothPolygon(200,220,15,6,0,1);
     SmoothLn1.SmoothPolygon(230,220,15,6,30,1);
     SmoothLn1.SmoothPolygon(260,220,15,3,23,1);
     {Sample of filled smooth polygon}
     SmoothLn1.Page1.Canvas.Brush.Color := clGreen;
     SmoothLn1.SmoothFilledPolygon(295,220,15,5,36,1);
     {Background color blocks for line edge highlight demo}
     SmoothLn1.Page1.Canvas.Brush.Color := clGreen;
     SmoothLn1.Page1.Canvas.FillRect(rect(75,250,150,310));
     SmoothLn1.Page1.Canvas.Brush.Color := clWhite;
     SmoothLn1.Page1.Canvas.FillRect(rect(150,250,225,310));

     {Example of lines with and without black border}
     SmoothLn1.SmoothPen.Width := 2;
     SmoothLn1.SmoothPen.Color := clWhite;
     SmoothLn1.SmoothPen.Mode := pmCopy;
     SmoothLn1.Page1.Canvas.MoveTo(10,250);
     SmoothLn1.SmoothLineTo(225,260,1);
     SmoothLn1.SmoothPen.Width := 5;
     SmoothLn1.SmoothPen.Mode := pmBlack;
     SmoothLn1.Page1.Canvas.MoveTo(10,270);
     SmoothLn1.SmoothLineTo(225,280,1);
     SmoothLn1.SmoothPen.Width := 2;
     SmoothLn1.SmoothPen.Mode := pmCopy;
     SmoothLn1.Page1.Canvas.MoveTo(10,290);
     SmoothLn1.SmoothBorderLineTo(225,300,1);
     SmoothLn1.SmoothBorderPolygon(200,260,10,5,0,1);
     {Create sprite image blocks for pinwheel animation}
     SmoothLn1.Page2.Canvas.Pen.Color := clWhite;
     SmoothLn1.Page2.Canvas.Pen.Width := 2;
     SmoothLn1.SmoothPen.Width := 2;
     RotationAngle := 0;
     YFrames := 50;
     While YFrames < 900 do
           begin
                XFrames := 50;
                While XFrames < 1000 do
                      begin
                           SmoothLn1.Page2.Canvas.MoveTo(XFrames + Round(45 * Sin(Pi * (180 + RotationAngle)/180)),YFrames + Round(45 * Cos(Pi * (180 + RotationAngle)/180)));
                           SmoothLn1.Page2.Canvas.LineTo(XFrames + Round(45 * Sin(Pi * RotationAngle/180)),YFrames + Round(45 * Cos(Pi * RotationAngle/180)));
                           SmoothLn1.Page2.Canvas.MoveTo(XFrames + Round(45 * Sin(Pi * (90 + RotationAngle)/180)),YFrames + Round(45 * Cos(Pi * (90 + RotationAngle)/180)));
                           SmoothLn1.Page2.Canvas.LineTo(XFrames + Round(45 * Sin(Pi * (270 + RotationAngle)/180)),YFrames + Round(45 * Cos(Pi * (270 + RotationAngle)/180)));
                           SmoothLn1.Page2.Canvas.MoveTo(XFrames + Round(45 * Sin(Pi * (135 + RotationAngle)/180)),YFrames + Round(45 * Cos(Pi * (135 + RotationAngle)/180)));
                           SmoothLn1.SmoothLineTo(XFrames + Round(45 * Sin(Pi * (315 + RotationAngle)/180)),YFrames + Round(45 * Cos(Pi * (315 + RotationAngle)/180)),2);
                           SmoothLn1.Page2.Canvas.MoveTo(XFrames + Round(45 * Sin(Pi * (225 + RotationAngle)/180)),YFrames + Round(45 * Cos(Pi * (225 + RotationAngle)/180)));
                           SmoothLn1.SmoothLineTo(XFrames + Round(45 * Sin(Pi * (45 + RotationAngle)/180)),YFrames + Round(45 * Cos(Pi * (45 + RotationAngle)/180)),2);
                           Inc(RotationAngle);
                           XFrames := XFrames + 100;
                      end;
                YFrames := YFrames + 100;
           end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SmoothLn1.Width := 400;
  SmoothLn1.Height := 400;
  Label2.Left := 440;
  Label3.Left := 440;
  Label4.Left := 440;
  Label6.Left := 440;
  Label7.Left := 440;
  Label8.Left := 440;
  Label9.Left := 440;
  Label10.Left := 440;
  Label12.Left := 440;
  
end;

procedure TForm1.TimerEx1Timer(Sender: TObject);
begin
     {50 ms timer routine to animate pinwheel}
     FrameX := FrameX + 100;
     If FrameX >= 1000 then
        begin
             FrameX := 0;
             FrameY := FrameY + 100;
             if FrameY >= 900 then FrameY := 0;
        end;
     SmoothLn1.Canvas.CopyRect(rect(250,250,349,349),SmoothLn1.Page2.Canvas,rect(FrameX,FrameY,FrameX+99,FrameY+99));
end;

end.
